# Analyse Statique de Programmes -- TP Analyse Statique

CentraleSupélec

Enseignant: Virgile Prevosto

## Préliminaires

Ce TP est la suite directe du [précédent](tp.md), et vise à implémenter une analyse des
signes et une analyse des intervalles en plus de la propagation de constante vue précédemment.

### Rappel Docker
L'image est ici: https://github.com/Frederic-Boulanger-UPS/docker-webtop-3asl et peut être utilisée soit localement, soit depuis `MyDocker`. De plus le répertoire  `config` est monté automatiquement dans le container docker si vous utilisez les scripts associé ([PowerShell](https://github.com/Frederic-Boulanger-UPS/docker-webtop-3asl/blob/main/start-3asl.ps1) pour Windows ou [sh](https://github.com/Frederic-Boulanger-UPS/docker-webtop-3asl/blob/main/start-3asl.sh) pour Linux/macOS/BSD). Ces scripts devraient automatiquement ouvrir un onglet de votre navigateur web avec une session IceWM. Si ce n'est pas le cas, vous pouvez le faire manuellement: http://localhost:3000

NB: l'interpréteur Python est `python3` et non `python`.

### Typage statique
Les fichiers proposés ont des annotations de types permettant de vérifier que
les programmes sont bien typés avant de les exécuter. On pourra utiliser
l'outil [`pyright`](https://microsoft.github.io/pyright/#/) pour la vérification. Il n'est pas présent sur l'image
Docker, mais peut s'installer via les commandes suivantes:
```sh
sudo apt update
sudo apt install pipx
sudo apt install pyright
```

Il dispose également d'un plugin vscode.

## Treillis des signes

## Treillis des intervalles, début

## Ajout de l'élargissement

## Treillis des intervalles, version finale
